<img src="https://plugins.jetbrains.com/files/12693/65249/icon/pluginIcon_dark.svg" height="100" alt="Plugin's icon"/>

# Flutter Enhancement Suite

[![Pub](https://img.shields.io/jetbrains/plugin/v/12693-flutter-enhancement-suite.svg?label=Flutter%20Enhancement%20Suite)](https://plugins.jetbrains.com/plugin/12693-flutter-enhancement-suite)

The essential plugin for making working with Flutter easier than ever!

## :sparkles: &nbsp;Features

<h4>Autocomplete Pub Dependencies</h4>
<p>When adding a new dependency to your pubspec.yaml file, suggestions will show up. After auto-completing the name, the latest version will be added automatically.</p>
<p>
<img src="https://giant.gfycat.com/PastObviousAmericanquarterhorse.gif" width="400" alt="Autocomplete pub dependencies screenshot"/>
<p>
<h4>Update Pub Dependencies</h4>
<p>If there's a new version available for a dependency, it will be highlighted. You can update these dependencies by opening the quick fix menu (Show Intention Actions) and choosing <em>Update package</em>.</p>
<p>
<img src="https://i.imgur.com/orIVdDj.png" width="400" alt="Update pub dependencies screenshot"/>
<p>
<h4>Dart & Flutter Code Snippets</h4>
A bunch of snippets/LiveTemplates for quicker coding. Use <code>Ctrl+Q</code> when hovering over a snippet to get a preview of it.<br>
(<a href="https://github.com/marius-h/flutter_enhancement_suite/blob/master/SNIPPETS.md">Click here to view all</a>)
<p>
<h4>Generate Widgets</h4>
<p>When creating a new file, choose the <em>"New Flutter Widget"</em> option.
Enter the name for your widget and select its type.</p>
<p>
<img src="https://i.imgur.com/FKQtOVa.png" width="400" alt="Generate widgets screenshot"/>
<p>
<h4>Generate Blocs</h4>
<p>When creating a new file, choose the <em>"New Flutter Bloc"</em> option.
Enter a name for your bloc and it will automatically generate all required classes for you.<br>

><strong>Please note:</strong> This requires you to add the package <em>"bloc"</em> to your pub dependencies.
<p>
<h4>Icon Previews</h4>
<p>When creating a new file, choose the <em>"New Flutter Bloc"</em> option.
Enter a name for your bloc and it will automatically generate all required classes for you.<br>

><strong>Please note:</strong> This requires you to add the package <em>"flutter_vector_icons"</em> to your pub dependencies. The only compatible iconpacks for now are FontAwesome, Ionicons and MaterialCommunityIcons.</p>
<p>
<img src="https://i.imgur.com/JB9MkjA.png" width="400" alt="Icon previews screenshot"/>
<p>


## :arrow_down: &nbsp;How to install?

You can install plugin directly from IntelliJ IDEA or Android Studio:
1. Open _Preferences_
2. Choose _Plugins_
3. Select the _Marketplace_ tab
4. Search for **Flutter Enhancement Suite**
5. Click on _install_

## :fire: &nbsp;What's new?

### 1.1.2
<ul>
    <li>Fixed compatibility issues with Android Studio 3.4.2</li>
</ul>

### 1.1.1
<ul>
    <li>Added icon previews</li>
    <li>Fixed issue caused by autocompleting pub dependencies</li>
</ul>

### 1.1.0
<ul>
    <li>Added "New Flutter Widget" option to the "New File" menu</li>
    <li>Added "New Flutter Bloc" option to the "New File" menu</li>
    <li>Added even more snippets</li>
    <li>Improved the performance of autocompleting pub dependencies</li>
</ul>

### 1.0.0
<ul>
    <li>Added support for automatically checking for updates in pubspec.yaml</li>
    <li>Added support for autocompleting pub.dev dependencies</li>
    <li>Added snippets</li>
</ul>

## :handshake:  &nbsp;How can I contribute to this plugin?

Feel free to send a pull request or file an issue.